Edit

Share via


Query Execution - Execute Query

Executes a query against a dataflow and returns the result.

Note

This API is part of a Preview release and is provided for evaluation and development purposes only. It may change based on feedback and is not recommended for production use.

Executes a specified query against a dataflow and streams the results in Apache Arrow format. Supports using custom mashup documents for advanced scenarios.

This API supports long running operations (LRO).

Permissions

The caller must have execute permissions for the dataflow.

Required Delegated Scopes

Dataflow.Execute.All or Item.Execute.All.

Microsoft Entra supported identities

This API supports the Microsoft identities listed in this section.

Identity Support
User Yes
Service principal and Managed identities Yes

Interface

POST https://api.fabric.microsoft.com/v1/workspaces/{workspaceId}/dataflows/{dataflowId}/executeQuery

URI Parameters

Name In Required Type Description
dataflowId
path True

string (uuid)

The Dataflow ID.

workspaceId
path True

string (uuid)

The workspace ID.

Request Body

Name Required Type Description
queryName True

string

The name of the query to execute from the dataflow (or from the custom mashup document if provided).

customMashupDocument

string

Optional custom mashup document to override the dataflow's default mashup.

Responses

Name Type Description
200 OK

file

Query result was succesfully written. Results are streamed in Apache Arrow format. Refer to the Arrow documentation on how to read the stream in Python and other languages.

Errors encountered during query execution or during streaming will be in an additional column at the end named 'PQ Arrow Metadata'.

Media Type: "application/vnd.apache.arrow.stream"

202 Accepted

Request accepted, query execution in progress.

Headers

  • Location: string
  • x-ms-operation-id: string
  • Retry-After: integer
429 Too Many Requests

ErrorResponse

The service rate limit was exceeded. The server returns a Retry-After header indicating, in seconds, how long the client must wait before sending additional requests.

Headers

Retry-After: integer

Other Status Codes

ErrorResponse

Common error codes:

  • DataflowExecuteQueryError - Query execution failed. Some possible reasons include: the specified query name is invalid or empty, the custom mashup document is invalid, or the specified query name was not found in the dataflow (or in the custom mashup document if provided).

Definitions

Name Description
ErrorRelatedResource

The error related resource details object.

ErrorResponse

The error response.

ErrorResponseDetails

The error response details.

ExecuteQueryRequest

Request payload for executing a query against a dataflow.

ErrorRelatedResource

The error related resource details object.

Name Type Description
resourceId

string

The resource ID that's involved in the error.

resourceType

string

The type of the resource that's involved in the error.

ErrorResponse

The error response.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

moreDetails

ErrorResponseDetails[]

List of additional error details.

relatedResource

ErrorRelatedResource

The error related resource details.

requestId

string (uuid)

ID of the request associated with the error.

ErrorResponseDetails

The error response details.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

relatedResource

ErrorRelatedResource

The error related resource details.

ExecuteQueryRequest

Request payload for executing a query against a dataflow.

Name Type Description
customMashupDocument

string

Optional custom mashup document to override the dataflow's default mashup.

queryName

string

The name of the query to execute from the dataflow (or from the custom mashup document if provided).